﻿using System;
using System.Net;
using System.IO;
using System.Runtime.InteropServices;

namespace DVA.Info
{
    public class ExternalIP
    {
        public ExternalIP() { }

        public string IPAddress()
        {
            return GetExternalIP();
        }

        public string HTMLSource(string url)
        {
            return GetHTMLSource(url);
        }

        public static string GetExternalIP()
        {
            string tmp = GetHTMLSource("http://whatismyip.com/automation/n09230945.asp");
            if (string.IsNullOrEmpty(tmp))
                return "0.0.0.0";

            return tmp;
        }

        public static string GetHTMLSource(string url)
        {
            try
            {
                HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(url);
                request.CachePolicy = new System.Net.Cache.RequestCachePolicy(System.Net.Cache.RequestCacheLevel.Reload);
                System.Net.HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                Stream dataStream = response.GetResponseStream();
                StreamReader reader = new StreamReader(dataStream);
                String responseText = reader.ReadToEnd();
                reader.Close();
                dataStream.Close();
                response.Close();

                return responseText;
            }
            catch (System.Net.WebException ex)
            {
                return string.Empty;
            }
        }
    }
}
